
!AXAnnouncer methodsFor: '*announcements-extensions' stamp: 'sas 2/27/2009 11:15'!
hasSubscriptionFor: anObject 
	"Answers true if the receiver has a subscription for anObject"
	
	^ (registry subscriptionsOf: anObject) notEmpty! !

!AXAnnouncer methodsFor: '*announcements-extensions' stamp: 'sas 2/26/2009 22:50'!
hasSubscriptionFor: anObject to: anAnnouncementClass
	"Answers true if the receiver has a subscription for anObject 
	to receive any messages for the ocurrence of anAnnouncementClass"
	
	^ (registry subscriptionsOf: anObject for: anAnnouncementClass) notEmpty! !

!AXAnnouncer methodsFor: '*announcements-extensions' stamp: 'sas 2/26/2009 22:51'!
ifNotYetSubscribe: anAnnouncementClass send: aSelector to: anObject
	"Subscribes anObject to receive aSelector message 
	when anAnnouncementClass occurs but does that
	only if anObject is not previously subscrbed."

	(self hasSubscriptionFor: anObject to: anAnnouncementClass) ifTrue:[^self].

	self 
		when: anAnnouncementClass 
		send: aSelector 
		to: anObject! !

!AXAnnouncer methodsFor: '*announcements-extensions' stamp: 'sebastian.sastre 10/6/2009 20:44'!
unsubscribeNoFail: anObject 
	"Unsubscribes anObject and don't fail if no subscription is found'"
	^ (self hasSubscriptionFor: anObject) ifTrue:[
		self unsubscribe: anObject]
	! !
